From e3bd25281eab155d1387cc0e76abd81bce0d2016 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Mon, 29 Apr 2013 22:23:26 +0200
Subject: [PATCH] WIP amd upgrade

---
 contrib/amd/AUTHORS                            |  168 +-
 contrib/amd/BUGS                               |  201 +-
 contrib/amd/COPYING                            |    2 +-
 contrib/amd/ChangeLog                          |11748 ++++++++++++++++++------
 contrib/amd/FAQ                                |   69 +
 contrib/amd/FREEBSD-Xlist                      |  146 +-
 contrib/amd/FREEBSD-upgrade                    |   91 +-
 contrib/amd/INSTALL                            |  239 +-
 contrib/amd/MIRRORS                            |   50 -
 contrib/amd/MIRRORS.html                       |  106 +
 contrib/amd/MIRRORS.txt                        |   60 +
 contrib/amd/NEWS                               |  737 ++-
 contrib/amd/README                             |   27 +-
 contrib/amd/README.attrcache                   |  129 +
 contrib/amd/README.ldap                        |   57 +
 contrib/amd/README.y2k                         |    8 +-
 contrib/amd/TODO                               |  177 -
 contrib/amd/amd/am_ops.c                       |  211 +-
 contrib/amd/amd/amd.8                          |  300 +-
 contrib/amd/amd/amd.c                          |  257 +-
 contrib/amd/amd/amd.h                          |  735 ++-
 contrib/amd/amd/amfs_auto.c                    | 1493 +---
 contrib/amd/amd/amfs_direct.c                  |   30 +-
 contrib/amd/amd/amfs_error.c                   |   59 +-
 contrib/amd/amd/amfs_generic.c                 | 1262 +++
 contrib/amd/amd/amfs_host.c                    |  181 +-
 contrib/amd/amd/amfs_inherit.c                 |  200 -
 contrib/amd/amd/amfs_link.c                    |   78 +-
 contrib/amd/amd/amfs_linkx.c                   |   34 +-
 contrib/amd/amd/amfs_nfsl.c                    |  143 +-
 contrib/amd/amd/amfs_nfsx.c                    |  176 +-
 contrib/amd/amd/amfs_program.c                 |   64 +-
 contrib/amd/amd/amfs_root.c                    |   30 +-
 contrib/amd/amd/amfs_toplvl.c                  |  363 +-
 contrib/amd/amd/amfs_union.c                   |   52 +-
 contrib/amd/amd/amq_subr.c                     |  213 +-
 contrib/amd/amd/amq_svc.c                      |   96 +-
 contrib/amd/amd/autil.c                        |  623 +-
 contrib/amd/amd/clock.c                        |   34 +-
 contrib/amd/amd/conf.c                         |  589 ++-
 contrib/amd/amd/conf_parse.y                   |   25 +-
 contrib/amd/amd/conf_tok.l                     |   22 +-
 contrib/amd/amd/get_args.c                     |  262 +-
 contrib/amd/amd/info_exec.c                    |  423 +
 contrib/amd/amd/info_file.c                    |   42 +-
 contrib/amd/amd/info_hesiod.c                  |   26 +-
 contrib/amd/amd/info_ldap.c                    |  268 +-
 contrib/amd/amd/info_ndbm.c                    |   15 +-
 contrib/amd/amd/info_nis.c                     |   19 +-
 contrib/amd/amd/info_nisplus.c                 |   58 +-
 contrib/amd/amd/info_passwd.c                  |   17 +-
 contrib/amd/amd/info_union.c                   |   28 +-
 contrib/amd/amd/map.c                          |  724 +-
 contrib/amd/amd/mapc.c                         |  339 +-
 contrib/amd/amd/mntfs.c                        |  121 +-
 contrib/amd/amd/nfs_prot_svc.c                 |   96 +-
 contrib/amd/amd/nfs_start.c                    |  193 +-
 contrib/amd/amd/nfs_subr.c                     |  391 +-
 contrib/amd/amd/ops_TEMPLATE.c                 |   52 +-
 contrib/amd/amd/ops_autofs.c                   | 1281 ---
 contrib/amd/amd/ops_cachefs.c                  |   67 +-
 contrib/amd/amd/ops_cdfs.c                     |   95 +-
 contrib/amd/amd/ops_efs.c                      |   58 +-
 contrib/amd/amd/ops_lofs.c                     |   55 +-
 contrib/amd/amd/ops_mfs.c                      |    5 +-
 contrib/amd/amd/ops_nfs.c                      |  634 +-
 contrib/amd/amd/ops_nfs3.c                     |    5 +-
 contrib/amd/amd/ops_nullfs.c                   |    5 +-
 contrib/amd/amd/ops_pcfs.c                     |  123 +-
 contrib/amd/amd/ops_tfs.c                      |    5 +-
 contrib/amd/amd/ops_tmpfs.c                    |    5 +-
 contrib/amd/amd/ops_ufs.c                      |   65 +-
 contrib/amd/amd/ops_umapfs.c                   |    5 +-
 contrib/amd/amd/ops_unionfs.c                  |    5 +-
 contrib/amd/amd/ops_xfs.c                      |   59 +-
 contrib/amd/amd/opts.c                         |  506 +-
 contrib/amd/amd/readdir.c                      |  498 +
 contrib/amd/amd/restart.c                      |  312 +-
 contrib/amd/amd/rpc_fwd.c                      |   76 +-
 contrib/amd/amd/sched.c                        |   72 +-
 contrib/amd/amd/srvr_amfs_auto.c               |   24 +-
 contrib/amd/amd/srvr_nfs.c                     |  630 +-
 contrib/amd/amq/amq.8                          |  265 +-
 contrib/amd/amq/amq.c                          |  437 +-
 contrib/amd/amq/amq.h                          |    6 +-
 contrib/amd/amq/amq_clnt.c                     |   37 +-
 contrib/amd/amq/amq_xdr.c                      |   24 +-
 contrib/amd/amq/pawd.1                         |   50 +-
 contrib/amd/amq/pawd.c                         |   85 +-
 contrib/amd/aux_conf.h.in                      |   58 +
 contrib/amd/bootstrap                          |  108 +
 contrib/amd/conf/checkmount/checkmount_bsd44.c |    5 +-
 contrib/amd/conf/hn_dref/hn_dref_default.h     |    2 -
 contrib/amd/conf/mtab/mtab_bsd.c               |   11 +-
 contrib/amd/conf/nfs_prot/nfs_prot_freebsd2.h  |   10 +-
 contrib/amd/conf/nfs_prot/nfs_prot_freebsd3.h  |   61 +-
 contrib/amd/conf/sa_dref/sa_dref_bsd44.h       |    1 +
 contrib/amd/conf/transp/transp_sockets.c       |  318 +-
 contrib/amd/conf/trap/trap_default.h           |    1 +
 contrib/amd/conf/umount/umount_bsd44.c         |   55 +-
 contrib/amd/doc/am-utils.texi                  | 2147 +++--
 contrib/amd/doc/stamp-vti                      |    7 +-
 contrib/amd/doc/texinfo.tex                    | 7379 +++++++++------
 contrib/amd/doc/version.texi                   |    7 +-
 contrib/amd/fixmount/fixmount.8                |  143 +-
 contrib/amd/fixmount/fixmount.c                |   30 +-
 contrib/amd/fsinfo/fsi_analyze.c               |   68 +-
 contrib/amd/fsinfo/fsi_data.h                  |    9 +-
 contrib/amd/fsinfo/fsi_dict.c                  |    5 +-
 contrib/amd/fsinfo/fsi_gram.y                  |   21 +-
 contrib/amd/fsinfo/fsi_lex.l                   |   18 +-
 contrib/amd/fsinfo/fsi_util.c                  |   40 +-
 contrib/amd/fsinfo/fsinfo.8                    |  100 +-
 contrib/amd/fsinfo/fsinfo.c                    |   21 +-
 contrib/amd/fsinfo/fsinfo.h                    |   25 +-
 contrib/amd/fsinfo/wr_atab.c                   |   16 +-
 contrib/amd/fsinfo/wr_bparam.c                 |    5 +-
 contrib/amd/fsinfo/wr_dumpset.c                |    5 +-
 contrib/amd/fsinfo/wr_exportfs.c               |    5 +-
 contrib/amd/fsinfo/wr_fstab.c                  |    7 +-
 contrib/amd/hlfsd/hlfsd.8                      |  254 +-
 contrib/amd/hlfsd/hlfsd.c                      |  209 +-
 contrib/amd/hlfsd/hlfsd.h                      |   32 +-
 contrib/amd/hlfsd/homedir.c                    |  120 +-
 contrib/amd/hlfsd/nfs_prot_svc.c               |   35 +-
 contrib/amd/hlfsd/stubs.c                      |  131 +-
 contrib/amd/include/am_compat.h                |  135 +-
 contrib/amd/include/am_defs.h                  |  338 +-
 contrib/amd/include/am_utils.h                 |  730 +--
 contrib/amd/include/am_xdr_func.h              |  184 +-
 contrib/amd/include/amq_defs.h                 |    8 +-
 contrib/amd/include/mount_headers1.h           |  216 +
 contrib/amd/include/mount_headers2.h           |   87 +
 contrib/amd/ldap-id.ms                         |  306 +
 contrib/amd/ldap-id.txt                        |  360 +
 contrib/amd/ldap.schema                        |   52 +
 contrib/amd/libamu/alloca.c                    |  504 -
 contrib/amd/libamu/amu.h                       |    7 +-
 contrib/amd/libamu/clnt_sperrno.c              |  147 -
 contrib/amd/libamu/hasmntopt.c                 |   15 +-
 contrib/amd/libamu/misc_rpc.c                  |   52 +-
 contrib/amd/libamu/mount_fs.c                  |  593 +-
 contrib/amd/libamu/mtab.c                      |  167 +-
 contrib/amd/libamu/nfs_prot_xdr.c              |    5 +-
 contrib/amd/libamu/strerror.c                  |   68 +
 contrib/amd/libamu/strutil.c                   |  270 +
 contrib/amd/libamu/util.c                      |  176 -
 contrib/amd/libamu/wire.c                      |  190 +-
 contrib/amd/libamu/xdr_func.c                  |  483 +-
 contrib/amd/libamu/xutil.c                     |  360 +-
 contrib/amd/mk-amd-map/mk-amd-map.8            |   43 +-
 contrib/amd/mk-amd-map/mk-amd-map.c            |   49 +-
 contrib/amd/scripts/am-eject.in                |   11 +-
 contrib/amd/scripts/amd.conf-sample            |  119 +-
 contrib/amd/scripts/amd.conf.5                 | 1142 ++-
 contrib/amd/scripts/amd2ldif.in                |    6 +-
 contrib/amd/scripts/amd2sun.in                 |    2 +-
 contrib/amd/scripts/automount2amd.8            |   25 +-
 contrib/amd/scripts/automount2amd.in           |    4 +-
 contrib/amd/scripts/ctl-amd.in                 |   50 +-
 contrib/amd/scripts/ctl-hlfsd.in               |   19 +-
 contrib/amd/scripts/expn.1                     |  165 +-
 contrib/amd/scripts/expn.in                    |   20 +-
 contrib/amd/scripts/fix-amd-map.in             |    2 +-
 contrib/amd/scripts/fixrmtab.in                |    2 +-
 contrib/amd/scripts/lostaltmail.conf-sample    |   84 -
 contrib/amd/scripts/lostaltmail.in             |  649 --
 contrib/amd/scripts/redhat-ctl-amd.in          |  106 +
 contrib/amd/scripts/test-attrcache.in          |  135 +
 contrib/amd/scripts/wait4amd.in                |    2 +-
 contrib/amd/scripts/wait4amd2die.in            |    6 +-
 contrib/amd/tasks                              |  117 +-
 contrib/amd/vers.m4                            |    1 +
 contrib/amd/wire-test/wire-test.8              |   47 +-
 contrib/amd/wire-test/wire-test.c              |   10 +-
 etc/amd.map                                    |    5 +-
 etc/rc.d/amd                                   |   62 +-
 usr.sbin/amd/Makefile                          |    7 +-
 usr.sbin/amd/Makefile.inc                      |   29 +-
 usr.sbin/amd/amd/Makefile                      |   49 +-
 usr.sbin/amd/amq/Makefile                      |   18 +-
 usr.sbin/amd/doc/Makefile                      |    7 +-
 usr.sbin/amd/fixmount/Makefile                 |   23 +-
 usr.sbin/amd/fsinfo/Makefile                   |   22 +-
 usr.sbin/amd/hlfsd/Makefile                    |   19 +-
 usr.sbin/amd/include/Makefile                  |   23 +-
 usr.sbin/amd/include/amu_autofs_prot.h         |    8 +
 usr.sbin/amd/include/aux_conf.h                |   30 +-
 usr.sbin/amd/include/build_version.h           |    9 +-
 usr.sbin/amd/include/config.h                  | 2861 +++---
 usr.sbin/amd/include/newvers.sh                |   39 +-
 usr.sbin/amd/libamu/Makefile                   |   40 +-
 usr.sbin/amd/mk-amd-map/Makefile               |   13 +-
 usr.sbin/amd/pawd/Makefile                     |   18 +-
 usr.sbin/amd/scripts/Makefile                  |    7 +-
 usr.sbin/amd/wire-test/Makefile                |   14 +-
 196 files changed, 32719 insertions(+), 20175 deletions(-)
 create mode 100644 contrib/amd/FAQ
 delete mode 100644 contrib/amd/MIRRORS
 create mode 100644 contrib/amd/MIRRORS.html
 create mode 100644 contrib/amd/MIRRORS.txt
 create mode 100644 contrib/amd/README.attrcache
 create mode 100644 contrib/amd/README.ldap
 delete mode 100644 contrib/amd/TODO
 create mode 100644 contrib/amd/amd/amfs_generic.c
 delete mode 100644 contrib/amd/amd/amfs_inherit.c
 create mode 100644 contrib/amd/amd/info_exec.c
 delete mode 100644 contrib/amd/amd/ops_autofs.c
 create mode 100644 contrib/amd/amd/readdir.c
 create mode 100644 contrib/amd/aux_conf.h.in
 create mode 100755 contrib/amd/bootstrap
 delete mode 100644 contrib/amd/conf/hn_dref/hn_dref_default.h
 create mode 100644 contrib/amd/include/mount_headers1.h
 create mode 100644 contrib/amd/include/mount_headers2.h
 create mode 100644 contrib/amd/ldap-id.ms
 create mode 100644 contrib/amd/ldap-id.txt
 create mode 100644 contrib/amd/ldap.schema
 delete mode 100644 contrib/amd/libamu/alloca.c
 delete mode 100644 contrib/amd/libamu/clnt_sperrno.c
 create mode 100644 contrib/amd/libamu/strerror.c
 create mode 100644 contrib/amd/libamu/strutil.c
 delete mode 100644 contrib/amd/libamu/util.c
 delete mode 100644 contrib/amd/scripts/lostaltmail.conf-sample
 delete mode 100755 contrib/amd/scripts/lostaltmail.in
 create mode 100755 contrib/amd/scripts/redhat-ctl-amd.in
 create mode 100755 contrib/amd/scripts/test-attrcache.in
 create mode 100644 contrib/amd/vers.m4
 create mode 100644 usr.sbin/amd/include/amu_autofs_prot.h

diff --git a/contrib/amd/AUTHORS b/contrib/amd/AUTHORS
index 2618766..3c241d0 100644
--- a/contrib/amd/AUTHORS
+++ b/contrib/amd/AUTHORS
@@ -1,6 +1,4 @@
-# -*- text -*-
 PRIMARY AUTHORS AND MAJOR CONTRIBUTORS TO AM_UTILS:
-
 Original authors of amd were the Berkeley team and especially Jan-Simon
 Pendry.  Since then many people have contributed patches.
 
@@ -8,15 +6,16 @@ This file lists the ones who contributed major code changes, in no
 particular order, and I thank them all.  This is of course not to diminish
 the smaller contributes of the many others.  Thank you all.
 
-* Erez Zadok <ezk@cs.columbia.edu>
+* Erez Zadok <ezk@cs.sunysb.edu>
 
 The most significant changes were made by Erez Zadok in terms of bug fixes,
 ports, and new features added.  Erez Zadok is the current maintainer of
 am-utils, as of January 1997.
 
-There is a mailing list dedicated to developers of am-utils.  To subscribe
-to it, send mail to majordomo@majordomo.cs.columbia.edu, with the body of
-the message having the single line "subscribe amd-dev".
+* Ion Badulescu <ion@cs.columbia.edu>
+
+Co-maintainer of am-utils since late 1999: Linux and Solaris autofs support,
+Linux NFSv3 support, major code reorganization, etc...
 
 * Randall S. Winchester <rsw@glue.umd.edu>
 
@@ -85,6 +84,8 @@ syslog and/or syslog facilities.
 January 29, 1998: fix for 0.0.0.0 loopback on SunOS 3.X which defines
 IFF_ROUTE instead of IFF_LOOPBACK.
 
+May 30, 2000: correct logging types for addopts/mergeopts messages.
+
 * Daniel S. Riley  <dsr@mail.lns.cornell.edu>
 
 July 11, 1997: fixes to DU-4.0 to support string POSIX.1 signals, and struct
@@ -125,6 +126,12 @@ systems.  More misc fixes.
 February 3, 1998: don't start autofs listener unless autofs maps were in
 use.
 
+December 10, 1999: assorted fixed and lots of fixes to support in-kernel
+mount tables in Solaris 8.
+
+February 9, 2000: new debug options hrtime (hi-res timer) and xdrtrace.  bug
+fixes.
+
 * Jason Thorpe <thorpej@nas.nasa.gov>
 
 August 25, 1997: make amd work when talking to NIS+ servers in NIS
@@ -152,7 +159,7 @@ that do not allow forwarding of RPC messages to other services.
 August 10, 1997: netbsd and other bsd systems have a mask flag for
 pcfs_args (msdos mount).
 
-* Christos Zoulas <christos@deshaw.com>
+* Christos Zoulas <christos@zoulas.com>
 
 September 25, 1997: fix to initialize uid/gid fields of pcfs_args_t on
 netbsd.
@@ -161,6 +168,19 @@ October 10, 1997: compile time cleanups of printf()s in hlfsd code.  If nfs
 server is down or does not support a portmapper call, then mark it down as
 version 2, and try again later.
 
+November 29, 2002: compile fixes for NetBSD, a couple of bug fixes (one
+already fixed by maintainers)
+
+April 12, 2003: support new "unmount" option, useful to timeout removable
+local media mounts.
+
+October 12, 2004: patch to support two new amd.conf options, domain_strip
+and auto_attrcache.  Patch to cleanup NFS attribute-cache flag computation.
+Patch to fix an inconsistency in timeouts in the RPC code between socket and
+TLI implementations.  Patch to print version string (amd -v) after all
+options had been initialized, so we can print domain, host, and hostd.
+Linux patch to use umount2(2) if umount(2) fails.
+
 * Bill Paul <wpaul@ctr.columbia.edu>
 
 November 5, 1997: NFS v.3 support for AIX 4.2.1, which does *not* include
@@ -186,6 +206,8 @@ and proto.
 
 January 12, 1998: minor bug in output of amd -H.
 
+June 23, 2005: assortment of small compile bugs on aix4, and solaris 5/6/7.
+
 * Thomas Richter <richter@chemie.fu-berlin.de>
 
 January 13, 1998: use case insensitive comparisons for variables that need
@@ -261,6 +283,7 @@ copies, and using cached copies if map failed to reload.
 * Peter Breitenlohner <peb@mppmu.mpg.de>
 July 24, 1999: patch for linux 2.2.x to work with older libc5 systems, and
 nis_isup mis-logic fixes.
+December 13, 2001: report typos in scripts/amd.conf.5.
 
 * Dale Talcott <aeh@quest.cc.purdue.edu>
 July 26, 1999: added NFS3 support for AIX mounting.
@@ -274,3 +297,134 @@ September 5, 1999: pawd works for type:=nfsl.
 * Nick Williams <njw@ms.com>
 September 1, 1999: bug fix for incorrect symlinks when two locations are
 requested simultaneously.
+
+November 1, 1999: fixes to sync maps even if they are set to mapcache:=sync.
+
+January 19, 2000: fix (and reduce the incidence of) stale file handles when
+doing rapid mounts and umounts in succession.
+
+June 5, 2000: better handling of potential race-conditions during rapid
+u/mounts.  Correctly update d_drops stats for amq -s.
+
+* Johann Pfefferl <johann.pfefferl.jp@germany.agfa.com>
+November 16, 1999: fix to ldap code so repeated calls to string2he don't
+corrupt the string passed.
+
+* Amitha Perera <perera@cs.rpi.edu>
+December 9, 1999: detect all wire() interfaces correctly.
+
+* Steven Danz <sdanz@awc.kc.noaa.gov>
+January 25, 2000: allow browsable auto maps.
+
+* Wolfram Klaus	<klaus@physik.fu-berlin.de>.
+November 21, 2000: recognize proplist mnttab flag.
+
+* Thomas Klausner <tk@giga.or.at>
+November 21, 2000: lots of NetBSD fixes (many of which are generic).
+
+April 18, 2003: patch to reference am-utils info pages in man page.
+
+November 28, 2004: small fixes to typos in amd.conf(5) man page.
+
+* Olaf Kirch <okir@caldera.de>
+February 1, 2001: important Linux NFS error number mapping fixed
+
+* Ahmon Dancy <dancy@franz.com>
+February 9, 2001: Apple Rhapsody/Darwin/OS X port
+
+* Sebastien Bahloul <sebastien.bahloul@mangoosta.fr>
+July 3, 2001: LDAP fixes and updates to support new APIs
+
+March 27, 2002: LDAP bug and port to HPUX-11.
+
+* Philippe Troin <phil@fifi.org>
+July 12, 2001: Proper handling of GNU getopt, support for optionally
+disabling LDAP/Hesiod, fixes for the dev/nodev option on Linux.  Texi
+documentation fix.
+
+November 28, 2001: Bug fix.  Support "nolock" as an NFS option, not a
+generic mount option.
+
+July 17, 2003: pref:=null core dump fix.  libgdbm portability.  tcpd/librap
+support.  And a few other things for the 6.0 branch.
+
+* Trond Myklebust <trond.myklebust@fys.uio.no>
+January 10, 2002: Proper initialization of the timeo parameter on Linux, TCP
+_must_ have a timeout 2 orders of magnitude larger than UDP
+
+* George Ross <gdmr@dcs.ed.ac.uk>
+April 29, 2002: Rework of old code, support for wildcards in LDAP queries,
+and an FD leak fix.  Amd -A support.
+
+October 21, 2002: ldap_unbind fix for SIGPIPE, and support for LDAPv3
+protocol version parameter (with Tim Colles <timc@inf.ed.ac.uk>).
+
+* Matthias Scheler <tron@zhadum.de>
+June 14, 2002: patch to use "xlatecookie" NFS mount option.
+
+* Jun-ichiro itojun Hagino <itojun@iijlab.net>.
+June 11, 2002: minor fixes to support NetBSD 1.6A.
+
+* Sean Fagan <sef@apple.com>
+March 14, 2003: detect and use the MNT2_GEN_OPT_AUTOMNTFS mount flag
+on OS X / Darwin.
+
+* Hendrik Scholz <hscholz@raisdorf.net>
+June 9, 2003: mk-amd-map should open temp db file using O_EXCL.
+
+* Mark Davies <mark@mcs.vuw.ac.nz>
+July 14, 2003: define "xlatecookie" mnttab option if not defined (for
+NetBSD).  Support null hesiod entries if they start with a ".".
+
+* Eric S. Raymond <esr@thyrsus.com>
+December 9, 2003: fix unbalanced [] typo in fsinfo man page.
+
+* Martin Blapp <mb@imp.ch>
+July 6, 2004: recognize fields in pcfs_args_t in FreeBSD 5.
+
+* Dan Nelson <dnelson@allantgroup.com>
+August 2, 2004: pawd to recognize "host" type mounts.
+
+* Hauke Fath <hauke@Espresso.Rhein-Neckar.DE>
+August 3, 2004: pawd to recognize "linkx" type mounts.
+
+* Michael van Elst <M.van.Elst@science-computing.de>
+September 1, 2004: bug fix to avoid race condition in calls to mntctl on
+AIX.
+
+* Jonathan Chen <jon+amd@spock.org>
+October 22, 2004: patch/fix to move mlock/mlockall/plock code after the
+fork().
+June 29, 2005: core dump going off end of exported_ap[] array.
+September 29, 2005: patch/fix for pawd not to go into an infinite loop.
+October 25, 2005: patch/fix for pawd to repeatedly resolve path.
+
+* David Rage <rage@ucl.ac.uk>
+January 17, 2005: prevent Amd from logging 'Read-only filesystem' errors
+when the mount point has an ancestor (i.e. '/') that is mounted read-only.
+
+* Kevin Layer <layer@franz.com>
+January 28, 2005: basic instructions how to setup Amd on Mac OS-X.
+
+* Dan Ottavio <dottavio@ic.sunysb.edu>
+March 2, 2005: new global amd.conf option debug_mtab_file, to set the debug
+mtab file when using debug_options=mtab.  Default has changed from "./mtab"
+to "/tmp/mtab" to avoid security problem.  Bug fixed to ensure that Amd
+terminates properly even mtab file doesn't exist.
+
+* Erik Kline <ekline at ekline dot com>
+January 3, 2005: implementation of executable maps for Amd.
+
+* Jim Zajkowski <jim.zajkowski@gmail.com>
+March 14, 2005: small patch to amd2ldif.
+
+* Adam Morley <adam at gmi dot com>
+January 27, 2005: synchronize what amd2ldif does vs. what the ldap.schema
+expects.
+
+* Graeme Wilford <G.Wilford@surrey.ac.uk>
+July 4, 2005: buffer overflow in pawd.
+
+* Steve Plite <splite-amutils@sigint.cs.purdue.edu>
+September 22, 2005: repair reversed meaning of D_AMQ, so amq will unregister
+on exit.
